#ifndef CONTROLLER_H
#define CONTROLLER_H

#include "gaming-core/input/Buttons.h"
#include "gaming-core/math/Vector.h"

class Controller {
    Buttons& buttons;

public:
    const ButtonList& list;
    const Button& left;
    const Button& right;
    const Button& up;
    const Button& down;
    const Button& jump;
    const Button& sneak;
    const Button& camLeft;
    const Button& camRight;
    const Button& camUp;
    const Button& camDown;

    const MouseList& mouseList;
    const Button& leftClick;
    const Button& rightClick;

    Controller(Buttons& buttons);

    Vector2 getMouse() const;
    Vector2 getMouseChange() const;
};

#endif